<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>scripts.count_abstracts &#8212; NLP004  documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=4f649999" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=039e1c02" />
    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for scripts.count_abstracts</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">os</span><span class="o">,</span> <span class="nn">os.path</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">subprocess</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>

<div class="viewcode-block" id="main">
<a class="viewcode-back" href="../../scripts/count_abstracts.html#scripts.count_abstracts.main">[docs]</a>
<span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">relevant_publishers</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    main function for count_abstracts script. Counts abstracts in the given directory.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        path (str): directory, where to count abstracts.</span>
<span class="sd">        relevant_publishers (str): path to csv file with result from get_list_of_publishers.py</span>

<span class="sd">    Returns:</span>
<span class="sd">        </span>
<span class="sd">        int: Total number of abstracts for given publishers (hard coded to Elsevier and Springer).</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="n">bash_script_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span>
        <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span>
            <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">),</span> 
            <span class="s1">&#39;count_abstracts.sh&#39;</span>
        <span class="p">)</span>
    <span class="p">)</span>

    <span class="n">subprocess</span><span class="o">.</span><span class="n">run</span><span class="p">([</span><span class="s1">&#39;bash&#39;</span><span class="p">,</span> <span class="n">bash_script_path</span><span class="p">,</span> <span class="n">path</span><span class="p">])</span>

    <span class="n">relevant_publishers</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="n">relevant_publishers</span><span class="p">,</span> <span class="n">delimiter</span><span class="o">=</span><span class="s1">&#39;,&#39;</span><span class="p">,</span> <span class="n">quotechar</span><span class="o">=</span><span class="s1">&#39;&quot;&#39;</span><span class="p">)</span>

    <span class="n">api_publisher</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;Elsevier&#39;</span><span class="p">,</span> <span class="s1">&#39;Springer-Verlag&#39;</span><span class="p">}</span>

    <span class="n">relevant_publishers_filtered</span> <span class="o">=</span> <span class="n">relevant_publishers</span><span class="p">[</span><span class="o">~</span><span class="p">(</span><span class="n">relevant_publishers</span><span class="p">[</span><span class="s1">&#39;publisher&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">isin</span><span class="p">(</span><span class="n">api_publisher</span><span class="p">)</span> <span class="o">|</span> <span class="n">relevant_publishers</span><span class="p">[</span><span class="s1">&#39;publisher&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">str</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s1">&#39;Wiley&#39;</span><span class="p">))]</span>

    <span class="n">sum_occurrences_others</span> <span class="o">=</span> <span class="n">relevant_publishers_filtered</span><span class="p">[</span><span class="s1">&#39;occurrences&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span>

    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Elsevier: &#39;</span><span class="p">,</span> <span class="n">relevant_publishers</span><span class="p">[</span><span class="n">relevant_publishers</span><span class="p">[</span><span class="s1">&#39;publisher&#39;</span><span class="p">]</span><span class="o">==</span><span class="s1">&#39;Elsevier&#39;</span><span class="p">][</span><span class="s1">&#39;occurrences&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">sum</span><span class="p">())</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Springer: &#39;</span><span class="p">,</span> <span class="n">relevant_publishers</span><span class="p">[</span><span class="n">relevant_publishers</span><span class="p">[</span><span class="s1">&#39;publisher&#39;</span><span class="p">]</span><span class="o">==</span><span class="s1">&#39;Springer-Verlag&#39;</span><span class="p">][</span><span class="s1">&#39;occurrences&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">sum</span><span class="p">())</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Wiley: &#39;</span><span class="p">,</span> <span class="n">relevant_publishers</span><span class="p">[</span><span class="n">relevant_publishers</span><span class="p">[</span><span class="s1">&#39;publisher&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">str</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s1">&#39;Wiley&#39;</span><span class="p">)][</span><span class="s1">&#39;occurrences&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">sum</span><span class="p">())</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Others: &#39;</span><span class="p">,</span> <span class="n">sum_occurrences_others</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">relevant_publishers</span><span class="p">[</span><span class="n">relevant_publishers</span><span class="p">[</span><span class="s1">&#39;publisher&#39;</span><span class="p">]</span><span class="o">==</span><span class="s1">&#39;Elsevier&#39;</span><span class="p">][</span><span class="s1">&#39;occurrences&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span> <span class="o">+</span> <span class="n">relevant_publishers</span><span class="p">[</span><span class="n">relevant_publishers</span><span class="p">[</span><span class="s1">&#39;publisher&#39;</span><span class="p">]</span><span class="o">==</span><span class="s1">&#39;Springer-Verlag&#39;</span><span class="p">][</span><span class="s1">&#39;occurrences&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
    <span class="n">relevant_publishers</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span>
    <span class="n">main</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">relevant_publishers</span><span class="p">)</span>
    
    




<span class="c1"># print len([name for name in os.listdir(&#39;.&#39;) if os.path.isfile(name)])</span>
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">NLP004</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../modules.html">python</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pipe.html">pipe</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Ughur Mammadzada.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>